local frameHandler, frameEvents = CreateFrame("Frame"),{} --Frames are not frames in the sense of 2d panels, but is pmuch a table.
local mailOpen = false

function frameEvents:ADDON_LOADED(loaded)
	if loaded == "mailSanctuary" then
		print("Mail Sanctuary loaded!")
	end
end

local function HandleBadMail()
	local numItems, totalItems = GetInboxNumItems()

	local unreadMessages = 0
	for i=1, numItems do
		if select(9, GetInboxHeaderInfo(i)) == false then
			unreadMessages = unreadMessages + 1
		end
	end

	local hasMail = HasNewMail() and unreadMessages > 0

	if not hasMail then
		MiniMapMailFrame:Hide()
		return
	end
end

function frameEvents:SHOW(...)
	HandleBadMail()
end

function frameEvents:MAIL_INBOX_UPDATE(...)
	HandleBadMail()
end

function frameEvents:MAIL_HIDE(...)
	HandleBadMail()
end

frameHandler:SetScript("OnEvent", function(self, event, ...)
	frameEvents[event](self, ...) 
end)

for k, v in pairs(frameEvents) do
	frameHandler:RegisterEvent(k) -- Register all events for which handlers have been defined
end
